﻿Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim ds As New DataSet()
        Dim t1 As DataTable = ds.Tables.Add("table1")
        t1.Columns.Add("id", GetType(Integer)).AutoIncrement = True
        t1.Columns.Add("Name", GetType(String))
        t1.Columns.Add("Quantity", GetType(Integer))
        t1.Columns.Add("Total Quantity", GetType(Integer))
        t1.Columns.Add("Date", GetType(DateTime))
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 50, 60, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Appliances", 5, 20, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "FastFood", 20, 32, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Furniture", 12, 79, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Meat", 40, 52, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Fruits", 25, 28, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Vegetables", 30, 44, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Cars", 13, 200, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Tools", 60, 75, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Estate", 5, 30, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Motorcycles", 10, 32, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Clothes", 40, 69, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Shoes", 24, 40, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Games", 53, 55, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 42, 42, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Movies", 38, 44, New DateTime(2009, 2, 28)})
        UltraGrid1.DataSource = ds

    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        'Add the GroupByRow
        e.Layout.Bands(0).SortedColumns.Add(e.Layout.Bands(0).Columns("Date"), False, True)
        'Enlarges the Column so the whole summary fits
        e.Layout.Bands(0).Columns("Total Quantity").Width = 200
        'Removes the Caption
        e.Layout.Override.SummaryFooterCaptionVisible = Infragistics.Win.DefaultableBoolean.False
        'If you want the calculations to happen immediately instead once the GroupByRow has been expanded
        'Using this setting will make the grid perform slower when using large amounts of data
        UltraCalcManager1.DeferredCalculationsEnabled = False
    End Sub

    Private Sub UltraGrid1_InitializeRowsCollection(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeRowsCollectionEventArgs) Handles UltraGrid1.InitializeRowsCollection
        'This is showing how to have summaries only for grouped data
        'If you want the displayed all the time use InitializeLayout
        If (e.Rows.ParentRow IsNot Nothing Or e.Rows.IsGroupByRows) Then
            If (e.Rows.Band.Summaries.Count = 0) Then
                Dim Layout = UltraGrid1.DisplayLayout
                Layout.Bands(0).Summaries.Add(Infragistics.Win.UltraWinGrid.SummaryType.Sum,
                                                Layout.Bands(0).Columns("Quantity"))

                Dim formula As String = "sum([Quantity])/sum([Total Quantity])"

                Layout.Bands(0).Summaries.Add(formula, Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn,
                                                Layout.Bands(0).Columns("Total Quantity"))
                'Formats the Summary to look as percentage
                Layout.Bands(0).Summaries(1).DisplayFormat = "Percentage = {0:P}"
            End If
        ElseIf (e.Rows.ParentRow Is Nothing) Then
            e.Rows.Band.Summaries.Clear()
        End If
    End Sub
End Class
